﻿@page "/competitionTable"
@using Models.CompetitionData
@using Models.TeamData
@using Cronus_Server.Pages.Competition.CompetitionTeam.Dialog
@using Business.Repository.IRepository
@inject ICompetitionTeamRepository CompetitionTeamRepository
@inject ITeamSeasonRepository TeamSeasonRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager
@inject IModalDialogService ModalDialog

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Competition Table</h4>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th>RANK</th>
                    <th>Name</th>
                    <th>MP</th>
                    <th>W</th>
                    <th>D</th>
                    <th>L</th>
                    <th>S:C</th>
                    <th>Pts</th>
                </tr>
            </thead>
            <tbody>
                @if (CompetitionTeams.Any())
                {
                    int i = 1;
                    @foreach (var competitionTeam in CompetitionTeams.OrderByDescending(x => x.Points).ThenByDescending(x => x.GoalsScored - x.GoalsConceded))
                    {
                        <tr>
                            <td>@i</td>
                            @{i++;}
                            <td>@competitionTeam.Team.Name</td>
                            <td>@competitionTeam.Played</td>
                            <td>@competitionTeam.Won</td>
                            <td>@competitionTeam.Draw</td>
                            <td>@competitionTeam.Lost</td>
                            <td>@competitionTeam.GoalsScored : @competitionTeam.GoalsConceded</td>
                            <td>@competitionTeam.Points</td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
        <div class="text-center">
            <button class="btn btn-warning" @onclick="Recalculate">Recalculate table</button>
        </div>
    </div>
</div>

@code {
    [Parameter]
    public int CompetitionId { get; set; }
    private IEnumerable<CompetitionTeamDTO> CompetitionTeams { get; set; } = new List<CompetitionTeamDTO>();
    string Sport { get; set; }

    private int? DeleteCompetitionTeamId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        Sport = await localStorage.GetItemAsync<string>("sportName");
        await CompetitionTeamRepository.Recalculate(CompetitionId, Sport);
        CompetitionTeams = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId);
    }
    public async Task Recalculate()
    {
        await CompetitionTeamRepository.Recalculate(CompetitionId, Sport);
        await JsRuntime.ToastrSuccess("Table updated successfully!");
        CompetitionTeams = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId);
    }
}